subroutine correct_numberdp (x)
!'fix' Nan, Inf or underflow values so that they lie in real range.
! new NaN Value: 1e38
! new -inf value: -1e37
! new +inf value: 1e37
! underflow set to 0

implicit none

real(8), intent(inout) :: x

if (isnan(x)) then
    x=1.0e38
else
    if ( x > 1.0e37) x=1.0e37
    if ( x < -1.0e37) x=-1.0e37
    if (abs(x) < 1.0e-37) x=0.0
end if

end subroutine correct_numberdp

subroutine correct_numbersp (x)
!'fix' Nan, Inf or underflow values so that they lie in real range.
! new NaN Value: 1e38
! new -inf value: -1e37
! new +inf value: 1e37
! underflow set to 0

implicit none

real, intent(inout) :: x

if (isnan(x)) then
    x=1.0e38
else
    if ( x > 1.0e37) x=1.0e37
    if ( x < -1.0e37) x=-1.0e37
    if (abs(x) < 1.0e-37) x=0.0
end if

end subroutine correct_numbersp
